using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;


namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
// SCP 049
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "SCP-106", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "SCP-106 appears to be an elderly humanoid, with a general appearance of advanced decomposition. This appearance may vary, but the “rotting” quality is observed in all forms. SCP-106 causes a “corrosion” effect in all solid matter it touches, engaging a physical breakdown in materials several seconds after contact.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("SCP-106 logo.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("SCP-106 skin.png");
            var flesh = ModAPI.LoadTexture("SCP-106 flesh.png");
            var bone = ModAPI.LoadTexture("SCP-106 bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(46, 8, 6); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);

		



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "SCP-096", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "SCP-096 is a humanoid creature measuring approximately 2.38 meters in height. Subject shows very little muscle mass, with preliminary analysis of body mass suggesting mild malnutrition. Arms are grossly out of proportion with the rest of the subject's body, with an approximate length of 1.5 meters each.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("SCP-096 logo.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("SCP-096 skin.png");
            var flesh = ModAPI.LoadTexture("SCP-096 flesh.png");
            var bone = ModAPI.LoadTexture("SCP-096 bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130); 
            person.SetSecondBruiseColor(154, 0, 7); 
            person.SetThirdBruiseColor(207, 206, 120); 
            person.SetRottenColour(202, 199, 104); 
            person.SetBloodColour(108, 0, 4);
        }
    }
);
        







ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "SCP-3008-2", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "SCP-3008 is a Euclid anomaly. It is otherwise known as, The Infinite IKEA. Entering said location results in being unable to leave, or having little to no chances of getting out. The anomalies in 3008 are the Employees. These creatures have no face, and can vary from being incredibly tall, to super short.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("SCP-3008-1 logo.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("SCP-3008-1 skin.png");
            var flesh = ModAPI.LoadTexture("SCP-3008-1 flesh.png");
            var bone = ModAPI.LoadTexture("SCP-3008-1 bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130); 
            person.SetSecondBruiseColor(154, 0, 7); 
            person.SetThirdBruiseColor(207, 206, 120); 
            person.SetRottenColour(202, 199, 104); 
            person.SetBloodColour(108, 0, 4); 
        }
    }
);

        
   





ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "SCP-076-2 (Able)", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "He is a murderous barbarian who inhabits SCP-076-1, a Keter-class object under the SCP Foundation's containment, and is younger brother of SCP-073. He takes the form of an ancient Sumerian warrior inhabiting a giant, indestructible cube-shaped sarcophagus", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("SCP-076-2 logo.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("SCP-076-1 skin.png");
            var flesh = ModAPI.LoadTexture("SCP-076-1 flesh.png");
            var bone = ModAPI.LoadTexture("SCP-076-1 bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130); 
            person.SetSecondBruiseColor(154, 0, 7); 
            person.SetThirdBruiseColor(207, 206, 120); 
            person.SetRottenColour(202, 199, 104); 
            person.SetBloodColour(108, 0, 4); 
        }
    }
);






ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "SCP-073 (Cain)", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "SCP-073, who refers to itself as Cain, is generally polite and genial to all who speak to it, though it has been described as being cold and somewhat mechanical in its speech. It is very helpful, and enjoys aiding personnel in their daily actions, whatever they may be.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("SCP-073 logo.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("SCP-073 skin.png");
            var flesh = ModAPI.LoadTexture("SCP-073 flesh.png");
            var bone = ModAPI.LoadTexture("SCP-073 bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130); 
            person.SetSecondBruiseColor(154, 0, 7); 
            person.SetThirdBruiseColor(207, 206, 120); 
            person.SetRottenColour(202, 199, 104); 
            person.SetBloodColour(108, 0, 4); 
        }
    }
);
        



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
        NameOverride = "SCP-650", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "SCP-650 is a black statue of a stylized humanoid 167cm tall. The statue does not possess hands or facial features: the limbs taper off into rounded points and the head is a smooth surface all around. The default posture while under observation has the statue reaching upwards, head tilted as if facing the sky.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("SCP-650 logo.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("SCP-650 skin.png");
            var flesh = ModAPI.LoadTexture("SCP-650 flesh.png");
            var bone = ModAPI.LoadTexture("SCP-650 bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130); 
            person.SetSecondBruiseColor(154, 0, 7); 
            person.SetThirdBruiseColor(207, 206, 120); 
            person.SetRottenColour(202, 199, 104); 
            person.SetBloodColour(108, 0, 4); 
        }
    }
);
        }
    }
}